<?php

use Phinx\Migration\AbstractMigration;

class MailCreationClient extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $this->table('email')
            ->insert([
                'email_code' => 'email_reset_password',
                'email_nom' => 'Création de compte client',
                'email_description' => 'Mail envoyé au client lui signalant son mot de passe temporaire.',
                'email_statut' => 1
            ])
            ->saveData()
        ;

        /** @var \Phinx\Db\Adapter\PdoAdapter $adaptater */
        $adaptater = $this->getAdapter();
        $id = $adaptater->getConnection()->lastInsertId();

        $this->table('email_nom')
            ->insert([
                'email_id' => $id,
                'langue_id' => 1,
                "email_nom_sujet" => "Votre mot de passe %SITE_NAME%",
                "email_nom_content" => "Bonjour %CIVILITE_NOM_NOM% %CLIENT_PRENOM% %CLIENT_NOM%.<br>Vos identifiants sont:<br>Email: %CLIENT_EMAIL%<br>Mot de passe: %CLIENT_PASSWORD%<br>"
            ])
            ->saveData()
        ;
    }
}
