<?php

namespace Auth;

use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\HttpFoundation\RedirectResponse;

use Application;
use Client;
use Role;

class RoleAuth {

    public function __construct()
    {

    }

    /**
     * Function for register callback when we need check a role
     *
     * @param Event $event
     */
    public function register(Event $event)
    {
        $roles = (new Role())->get();
        $auth = $event->getAuth();

        foreach ($roles as $r) {
            $auth->register($r['role_code'], array('Auth\\RoleAuth', 'handle'));
        }
    }

    /**
     *
     * @param Auth $auth
     * @param string $roleName
     *
     * @return bool|RedirectResponse
     */
    public function handle(Auth $auth, $roleName)
    {
        $request = $auth->getRequest();
        $redirect = ($request->get('redirect') != false) ? $request->get('redirect') : 'login';

        $clientId = $request->getSession()->get('client_id');

        if (!empty($clientId)) {
            $client = new Client($clientId);
            $hasRole = $client->hasRole($roleName);
        }

        if (empty($clientId) || empty($hasRole)) {
            return new RedirectResponse(
                Application::getRouter()->getRouter()->generate($redirect)
            );
        }

        return true;
    }

}