<?php

// TODO a mettre a jour avec la nouvelle version

/**
 * Class Cheque_Cadeau
 */
class ChequeCadeau extends Model {

    const CC_UTILISE = 0;
    const CC_VALIDE = 1;
    const CC_JOUR_DEFAULT = 365;
    const CC_LONG_CODE = 10;

    public $table = 'cheque_cadeau';

    /**
     * @param array $formvars
     * @param string $champs
     * @return array|null
     *
     * Recuperation des ba valides
     */
    function get($formvars = array(), $champs = "") {

        $sql = "SELECT *";
        $sql.=", ROUND(cheque_cadeau_prix_ht * (1+taxe_taux),2) AS cheque_cadeau_prix_ttc";
        $sql.=", ROUND(cheque_cadeau_prix_ht,2) AS cheque_cadeau_prix_ht";
        $sql.=", ROUND(cheque_cadeau_prix_min * (1+taxe_taux),2) AS cheque_cadeau_prix_min_ttc";
        $sql.=", ROUND(cheque_cadeau_prix_min,2) AS cheque_cadeau_prix_min_ht";
        $sql.=", DATE_FORMAT(cheque_cadeau_date_debut,'%d/%m/%Y') AS date_debut";
        $sql.=", DATE_FORMAT(cheque_cadeau_date_fin,'%d/%m/%Y') AS date_fin";
        $sql.=", CONCAT('CC',cheque_cadeau_id) AS cc_id";
        $sql.=" FROM cheque_cadeau cc, taxe t";
        $sql.=" WHERE t.taxe_id = cc.taxe_id";

        if (!empty($formvars['cheque_cadeau_id']))
            $sql.=" AND cheque_cadeau_id = '" . $formvars['cheque_cadeau_id'] . "'";
        if (!empty($formvars['cheque_cadeau_code']))
            $sql.=" AND cheque_cadeau_code = '" . $formvars['cheque_cadeau_code'] . "'";

        $sql.=" AND cheque_cadeau_date_fin >= CURRENT_DATE()";
        $sql.=" AND cheque_cadeau_statut_id = '" . self::CC_VALIDE . "'";

        $sql.=" ORDER BY cheque_cadeau_date_fin";

        if (empty($champs)) {
            return $this->sql->getAll($sql);
        } else {
            $result = $this->sql->getOne($sql);
            return $result[$champs];
        }
    }

    // ajouter un cheque cadeau
    function addCC($formvars) {

        if (!isset($formvars['nb_jour']))
            $formvars['nb_jour'] = self::CC_JOUR_DEFAULT;

        if (!isset($formvars['cheque_cadeau_prix_min']))
            $formvars['cheque_cadeau_prix_min'] = 0;

        if (!isset($formvars['cheque_cadeau_date_debut']))
            $formvars['cheque_cadeau_date_debut'] = 'NOW()';

        if (!isset($formvars['taxe_id']))
            $formvars['taxe_id'] = 4;

        $sql = "INSERT INTO cheque_cadeau SET";
        $sql.=" cheque_cadeau_nom = '" . $formvars['cheque_cadeau_nom'] . "'";
        $sql.=", cheque_cadeau_code = '" . $formvars['cheque_cadeau_code'] . "'";
        $sql.=", cheque_cadeau_prix_ht = '" . $formvars['cheque_cadeau_prix_ht'] . "'";
        $sql.=", cheque_cadeau_prix_min = '" . $formvars['cheque_cadeau_prix_min'] . "'";
        $sql.=", taxe_id = '" . $formvars['taxe_id'] . "'";
        $sql.=", cheque_cadeau_date_ajout = NOW()";
        $sql.=", cheque_cadeau_date_debut = " . $formvars['cheque_cadeau_date_debut'] . " ";
        $sql.=", cheque_cadeau_date_fin = DATE_ADD(NOW(), INTERVAL " . $formvars['nb_jour'] . " DAY)";
        $sql.=", cheque_cadeau_statut_id = '" . self::CC_VALIDE . "'";

        $this->sql->query($sql);

        return $this->sql->db->insert_id;
    }

    // utilisation d'un cheque cadeau en mode de paiement
    function add($formvars = array()) {

        if (empty($formvars['cheque_cadeau_code']))
            return false;


        $arrCC = $this->get(array('cheque_cadeau_code' => $formvars['cheque_cadeau_code'], 'valide' => '1'));
        if (count($arrCC) == 0)
            return false;


        $paiement = new Paiement;

        // on verifie si le cc n'est pas deja enregistre
        if ($paiement->find(array('paiement_id' => $arrCC[0]['cheque_cadeau_id'], 'paiement_type' => 'CC')) !== false)
            return false;

        $panier = Panier::getInstance();
        $panierHT = $panier->aPayerHT();
        $panierTTC = $panier->aPayerTTC();

        // on verifie si montant d'achat min du CC ok
        if ($arrCC[0]['cheque_cadeau_prix_min'] > $panierHT)
            return false;

        // on ajoute le ba au panier
        $paramPaiement['paiement_id'] = $arrCC[0]['cheque_cadeau_id'];
        $paramPaiement['paiement_type'] = 'CC';
        $paramPaiement['paiement_nom'] = $arrCC[0]['cheque_cadeau_nom'] . " : " . $arrCC[0]['cheque_cadeau_code'];
        $paramPaiement['paiement_statut_id'] = 2;
        $paramPaiement['paiement_in_cmd'] = 1;
        $paramPaiement['paiement_total_ht'] = $arrCC[0]['cheque_cadeau_prix_ht'];
        $paramPaiement['paiement_total_ttc'] = $arrCC[0]['cheque_cadeau_prix_ttc'];
        // on calcule le montant affecte car le cheque cadeau ne peut etre superieur au montant du panier
        if ($panierHT < $arrCC[0]['cheque_cadeau_prix_ht'] || $panierTTC < $arrCC[0]['cheque_cadeau_prix_ttc']) {
            $paramPaiement['paiement_montant_ht'] = $panierHT;
            $paramPaiement['paiement_montant_ttc'] = $panierTTC;
        } else {
            $paramPaiement['paiement_montant_ht'] = $paramPaiement['paiement_total_ht'];
            $paramPaiement['paiement_montant_ttc'] = $paramPaiement['paiement_total_ttc'];
        }
        $paramPaiement['paiement_taxe'] = $arrCC[0]['taxe_taux'];
        $paramPaiement['paiement_class'] = 'Cheque_Cadeau';

        $paiement->add($paramPaiement);
    }

    // passe le cheque cadeau au statut utilise
    function usePaiement($ccId) {

        $sql = "UPDATE cheque_cadeau SET cheque_cadeau_statut_id = '" . self::CC_UTILISE . "' WHERE cheque_cadeau_id = '" . $ccId . "'";
        $this->sql->query($sql);
    }

    function changeStatut($idCommande, $newStatut, $formvars) {

        // on recupere les infos de la commande
        $commande = new Commande;
        list($arrCommande) = $commande->get(array('commande_id' => $idCommande));
        if (empty($arrCommande))
            return;


        switch ($newStatut) {
            case Commande::STATUT_EXPEDIE:
                for ($j = 0; $j < $formvars['produit_quantite']; $j++) {

                    // on genere le code
                    $string = "";
                    $chaine = "AZERTYUIOPQSDFGHJKLMWXCVBN1234567890";
                    for ($i = 0; $i < self::CC_LONG_CODE; $i++) {
                        $string .= $chaine[rand() % strlen($chaine)];
                    }

                    $cheque_cadeau = array();
                    $cheque_cadeau['cheque_cadeau_nom'] = $formvars['produit_nom'];
                    $cheque_cadeau['cheque_cadeau_code'] = $string;
                    $cheque_cadeau['cheque_cadeau_prix_ht'] = $formvars['produit_prix'];

                    $cc_id = $this->addCC($cheque_cadeau);


                    $arrFile = array();
                    $file['tmp_name'] = SITE_URL . "cc.php?cc_id=" . $cc_id;
                    $file['name'] = "CC" . $cc_id . ".pdf";
                    $file['type'] = "application/pdf";
                    array_push($arrFile, $file);


                    $email = new Email;
                    $paramEmail['to'] = $arrCommande['client_email'];
                    $paramEmail['texte'] = 'Email_cc';
                    $paramEmail['layout'] = 'bienvenue';
                    $paramEmail['tags'] = '';
                    $paramEmail['files'] = $arrFile;
                    $email->sendFromTxt($paramEmail);
                }
                break;
        }
    }

}
