<?php

/**
 * Class Pdf
 */
class Pdf
{
    // @TODO : implement param to save PDF

    function generate($htmlContent, $fileName='pdf', $header = '', $title = '', $output = 'D', $htmlheader = '', $htmlfooter = '')
    {

        if (empty($htmlContent))
            return;
        if (empty($title))
            $title = $fileName;

        if (!empty($header)) {
            $pdf = new $header(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
            if(!empty($htmlheader)){
                $pdf->setHtmlHeader($htmlheader);
            }
            if(!empty($htmlfooter)){
                $pdf->setHtmlFooter($htmlfooter);
            }
        } else {
            $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
        }


        // param
        $pdf->SetCreator(PDF_CREATOR);
        $pdf->SetTitle($title);

        //set margins
        
        if (!empty($header)) {
            $pdf->setCustomMargin();
        } else {
            // remove default header/footer
            $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
            $pdf->setPrintHeader(false);
            $pdf->setPrintFooter(false);
        }


        //set auto page breaks
        $pdf->SetAutoPageBreak(true, PDF_MARGIN_BOTTOM);

        // content
        $pdf->AddPage();
        $pdf->writeHTML($htmlContent);
        $pdf->lastPage();

        // sortie
        $out = $pdf->Output($fileName . '.pdf', $output);
        return $out;
    }

}

// Header & Footer pour les bon de commande, factures ...
class Pdf_Legal extends TCPDF
{
    public $htmlfooter='';
    public $htmlheader='';

    public function setHtmlHeader($html=''){
        $this->htmlheader=$html;
    }
    public function setHtmlFooter($html=''){
        $this->htmlfooter=$html;
    }

    public function setCustomMargin()
    {
        $this->SetMargins(10, 45, 15);

        if(empty($this->htmlheader)){
            $this->setPrintHeader(false);
        }
        if(empty($this->htmlfooter)){
            $this->setPrintFooter(false);
        }

        $this->SetFooterMargin(10);
        $this->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

    }

    public function Header()
    {
        if(!empty($this->htmlheader)){
            $this->writeHTML($this->htmlheader, true, false, true, false, '');
        }
    }

    public function Footer()
    {
        // Position at 25 mm from bottom
        $this->SetY(-25);

        if(!empty($this->htmlfooter)){
            $this->writeHTML($this->htmlfooter, true, false, true, false, '');

            // Pagination
            $this->Cell(0, 4, 'Page ' . $this->getAliasNumPage() . '/' . $this->getAliasNbPages(), 0, false, 'R', 0, '', 0, false, 'T', 'M');

        }
    }
}

